Summary: C++ library for HPC, networking, DB, memory, etc
Name: UpTools
Version: 8.5.4
Release: 13%{dist}
License: BSD with advertising
Group: Development/Libraries
Source: http://www.palermo.edu/ingenieria/%{name}-%{version}.tar.gz
Patch0: %{name}-8.5.4-64bit.patch
Patch1: %{name}-8.5.4-s390.patch
URL: http://www.palermo.edu/ingenieria/uptools_ingles.html
BuildRequires: mysql-devel
BuildRequires: postgresql-devel
BuildRequires: openssl-devel

%description
UpTools is an open source C++ development library that contains powerful
classes to facilitate and accelerate modern application development.
The following aspects are covered by the library: High performance computing
(HPC), Load distribution and parallel processing, Multi-threading, Time and
timers, Memory management, Text and strings, Database access, Networking, and
others.

%package devel
Summary: Header files and examples for UpTools C++ library
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: libstdc++-devel%{?_isa}
Requires: openssl-devel%{?_isa}
Requires: mysql-devel%{?_isa}
Requires: postgresql-devel%{?_isa}
 
%description devel
UpTools is an open source C++ development library that contains powerful
classes to facilitate and accelerate modern application development.
The following aspects are covered by the library: High performance computing
(HPC), Load distribution and parallel processing, Multi-threading, Time and
timers, Memory management, Text and strings, Database access, Networking, and
others. This package include headers to build apps using UpTools 
and example code.


%prep
%setup -q  
%patch0 -p1 -b .64bit
%patch1 -p1 -b .s390
iconv -f iso8859-1 -t utf-8 doc/tests/testUpTimer.cc  >  doc/tests/testUpTimer.cc.conv && touch -r doc/tests/testUpTimer.cc doc/tests/testUpTimer.cc.conv  && mv -f  doc/tests/testUpTimer.cc.conv doc/tests/testUpTimer.cc

mkdir doc/code_examples
# Timestamp is preserved
touch -r doc/tests doc/code_examples
cp -p doc/tests/*.cc doc/code_examples


%build


# We use unordered_map and unordered_set instead the hash_map and hash_set
%configure --disable-static --enable-experimental --disable-silent-rules LDFLAGS="-L%{_libdir}/mysql"

make %{?_smp_mflags} 

%install
make install DESTDIR=%{buildroot} INSTALL="install -p"

rm -rf  %{buildroot}/%{_docdir}/%{name}

# We don't want .la libtool archive
rm -f %{buildroot}%{_libdir}/libUpTools.la
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libUpTools.so.*
%doc README LICENSE doc/MULTITHREADING.INTRO doc/INTRO

%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/UpTools
%{_includedir}/UpTools/*
%{_libdir}/libUpTools.so
%doc LICENSE doc/README.FEDORA doc/code_examples

%changelog
* Fri Mar 25 2011 Dan Horák <dan@danny.cz> - 8.5.4-13
- fix build on 64-bit platforms (don't fiddle with libdir in configure)
- fix build on s390 where size_t is unsigned long

* Wed Mar 23 2011 Dan Horák <dan@danny.cz> - 8.5.4-12
- rebuilt for mysql 5.5.10 (soname bump in libmysqlclient)

* Tue Mar 01 2011 Sergio Belkin <sebelk@fedoraproject.org> - 8.5.4-11
- Fixed typo in previous changelog entry
- Fixed release number in previous changelog entry

* Mon Feb 28 2011 Sergio Belkin <sebelk@fedoraproject.org> - 8.5.4-10
- Used %%{_libdir} macro instead of the conditional statement ifarch
  and hardcoded paths

* Sat Feb 26 2011 Sergio Belkin <sbelki@palermo.edu> - 8.5.4-9
- Set LDFLAGS for mysqclient, in order to prevent misleading 
  messages from macro ax_ext_have_lib.m4
- Added libstdc++-devel
- Added --disable-silent-rules to configure script 
- Removed %%check section it is not needed
- Minor aesthetic changes to changelog

* Fri Feb 25 2011 Sergio Belkin <sbelki@palermo.edu> - 8.5.4-8
- Removed redundant "/usr/bin" before iconv
- Preserved timestamp using iconv
- Removed "-Wno-deprecated"
- Added parallel make
- Kept timestamps on install command
- fixed %%defattr macro
- Added openssl-devel%{?_isa}
- Removed message on scriplet
- Changed from hash_map and hash_set headers to unordered_map
- Using glob instead multiples lines of install command
- Fixed documentation files
- Disabled silent mode in %%check section

* Tue Feb 22 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-7
- Fixed License in order to match the actual license
- Clarified Base Package required
- Disabled static subpackage
- Removed .la libtool file instead of excluding
- %%check section added
- Minor change in %%description tags and Requires

* Thu Feb 18 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-6
- Removed files creation on %%post section
- Removed glibc-devel as BuildRequires

* Thu Feb 17 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-5
- Removed %%clean section
- Fixed a regression, there were incorrect paths in %%prep section

* Thu Feb 15 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-4
- Fixed LDFLAGS problem
- Fixed release RPM

* Thu Feb 03 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-3
- Polished install
- Added post-install action for devel subpackage
- README.FEDORA moved to devel package
- INSTALL file dropped as it is considered irrelevant
- Added symlink file to devel package and removed from non-devel package

* Mon Jan 31 2011 Sergio Belkin <sbelki@palermo.edu> 8.5.4-2
- Styles mixing fixed
- Added openssl-devel as BuildRequires
- Drop "." ant the end Summary
- Fixed BuildRoot
- Fixed Summary and Description
- Fixed %%pre and %%postun
- Fixed file-not-utf8
- Fixed spec file name

* Mon Jan 01 2011 Sergio Belkin <sbelki@palermo.edu> - 8.5.4-1
- first RPM made in Universidad de Palermo
